#include "wi.hpp"
#include "wi.moc"

#include <stdio.h>
#include <stdlib.h>

#include "../pics/field_0.xpm"
#include "../pics/field_1.xpm"
#include "../pics/field_2.xpm"
#include "../pics/field_3.xpm"
#include "../pics/field_4.xpm"
#include "../pics/field_5.xpm"
#include "../pics/field_6.xpm"
#include "../pics/field_7.xpm"
#include "../pics/field_8.xpm"
#include "../pics/field_9.xpm"
#include "../pics/field_10.xpm"
#include "../pics/field_11.xpm"
#include "../pics/field_12.xpm"
#include "../pics/field_13.xpm"
#include "../pics/edge.xpm"

const int xw=60;
const int yw=70;
feld m[xw*yw];

w::w(QWidget *parent, const char *name)
  : QWidget(parent,name)
{
  setBackgroundMode(NoBackground);
  resize(60*xw,60*yw);
  setFixedSize(size());

  for (int x=0;x<xw;x++)
    for (int y=0;y<yw;y++) {
      m[x+y*xw].mass=0.0;
      m[x+y*xw].cap=1.0;
      m[x+y*xw].rr=1000000000000.0;
      m[x+y*xw].ru=1000000000000.0;
      m[x+y*xw].type=feld::EDGE;
    };

  // oben
  for (int x=1;x<xw-1;x++)
    for (int y=1;y<45;y++) {
      m[x+y*xw].mass=0.0;
      m[x+y*xw].cap=1.0;
      m[x+y*xw].type=feld::FIELD;
    };

  // unten
  for (int x=1;x<xw-1;x++)
    for (int y=55;y<yw-1;y++) {
      m[x+y*xw].mass=1.0;
      m[x+y*xw].cap=1.0;
      m[x+y*xw].type=feld::FIELD;
    };

  // links
  for (int x=1;x<20;x++)
    for (int y=45;y<55;y++) {
      m[x+y*xw].mass=1.0;
      m[x+y*xw].cap=100000000.0;
    };
  
  // rechts
  for (int x=xw-1-20;x<xw-1;x++)
    for (int y=45;y<55;y++) {
      m[x+y*xw].mass=1.0;
      m[x+y*xw].cap=100000000.0;
    };
  

  // oben
  for (int x=1;x<xw-2;x++)
    for (int y=1;y<45-1;y++) {
      m[x+y*xw].rr=1;
      m[x+y*xw].ru=1;
    };

  // unten
  for (int x=1;x<xw-2;x++)
    for (int y=55;y<yw-2;y++) {
      m[x+y*xw].rr=1;
      m[x+y*xw].ru=1;
    };

  // midpath
  for (int x=22;x<xw-22-2;x++)
    for (int y=44;y<55;y++) {
      m[x+y*xw].rr=1;
      m[x+y*xw].ru=1;
      m[x+y*xw].type=feld::FIELD;
    };

  m[(xw-3)+(yw-2)*xw].rr=1; // pfusch...

  setMouseTracking(TRUE);
  butstat=0;

  pics[0]=new QPixmap((const char**)field_0_xpm);
  pics[1]=new QPixmap((const char**)field_1_xpm);
  pics[2]=new QPixmap((const char**)field_2_xpm);
  pics[3]=new QPixmap((const char**)field_3_xpm);
  pics[4]=new QPixmap((const char**)field_4_xpm);
  pics[5]=new QPixmap((const char**)field_5_xpm);
  pics[6]=new QPixmap((const char**)field_6_xpm);
  pics[7]=new QPixmap((const char**)field_7_xpm);
  pics[8]=new QPixmap((const char**)field_8_xpm);
  pics[9]=new QPixmap((const char**)field_9_xpm);
  pics[10]=new QPixmap((const char**)field_10_xpm);
  pics[11]=new QPixmap((const char**)field_11_xpm);
  pics[12]=new QPixmap((const char**)field_12_xpm);
  pics[13]=new QPixmap((const char**)field_13_xpm);
  edge=new QPixmap((const char**)edge_xpm);
};

w::~w()
{
  for (int x=0;x<14;x++) delete pics[x];
  delete edge;
};

void w::calculate()
{
  float delta=0.2;
  float Ic_t;
  int ptr;
  float neu[xw*yw];

  for (int y=1;y<yw-1;y++)
    for (int x=1;x<xw-1;x++) {
      Ic_t=0;
      ptr = x+y*xw;
      Ic_t -= (m[ptr].mass - m[ptr-1].mass) / m[ptr-1].rr;
      Ic_t -= (m[ptr].mass - m[ptr+1].mass) / m[ptr].rr;
      Ic_t -= (m[ptr].mass - m[ptr-xw].mass) / m[ptr-xw].ru;
      Ic_t -= (m[ptr].mass - m[ptr+xw].mass) / m[ptr].ru;
      neu[ptr]=((Ic_t * delta) / m[ptr].cap) + m[ptr].mass;
    };
  
  for (int y=1;y<yw-1;y++)
    for (int x=1;x<xw-1;x++)
      m[x+y*xw].mass=neu[x+y*xw];
};

void w::mousePressEvent( QMouseEvent *e )
{
  butstat=1;
  mouseMoveEvent(e);
};

void w::mouseReleaseEvent( QMouseEvent * )
{
  butstat=0;
  repaint(FALSE);
};

void w::mouseMoveEvent( QMouseEvent *e )
{
  if (butstat) {
    m[e->pos().x()/60 + (e->pos().y()/60)*xw ].mass = 1;
    m[e->pos().x()/60 + (e->pos().y()/60)*xw ].cap = 100;
  };
};

void w::paintEvent(QPaintEvent *)
{
  QPainter p;

  p.begin(this);
  
  for (int x=0;x<xw;x++)
    for (int y=0;y<yw;y++) {
      switch (m[x+y*xw].type)
	{
	case feld::EDGE:
	  p.drawPixmap(x*60,y*60,*edge);
	  break;
	case feld::FIELD:
	  int c=int(m[x+y*xw].mass*13+0.5);
	  if (c>13)c=13;
	  if (c<0)c=0;
	  p.drawPixmap(x*60,y*60,*pics[c]);
	  break;
	};
    };
  
  p.end();

  float sum=0;
  for (int y=1;y<yw-1;y++) 
    for (int x=1;x<xw-1;x++)
      sum+=m[x+y*xw].mass*m[x+y*xw].cap;
  printf("%f\n",sum);
};


app::app(QWidget *parent,const char *name)
  : QWidget (parent,name)
{
  QVBoxLayout *v = new QVBoxLayout(this,5);

  QScrollView *s = new QScrollView(this);
  a = new w(this);
  s->addChild(a);
  s->setMinimumSize(320,200);
  v->addWidget(s);

  QPushButton *p = new QPushButton("sucker",this);
  QObject::connect(p,SIGNAL(clicked()),this,SLOT(button()));
  p->setMinimumSize(p->sizeHint());
  p->setMaximumHeight(p->sizeHint().height());
  v->addWidget(p);

  v->activate();

  tim=0;
};

void app::timerEvent(QTimerEvent *)
{
  for (int x=0;x<20;x++) a->calculate();

  a->repaint(FALSE);
};

void app::button()
{
  if (tim) {
    killTimers();
    tim=0;
  }else{
    tim=startTimer(0);
  };
};
